	.extern paldata
joy	equ	$FF9200			; joystick ports
olp	equ	$FFC012			; object list pointer
binit	equ	$FFC020			; background
vp	equ	$FFC100			; vertical period
vs	equ	$FFC102			; vertical sync
vbb	equ	$FFC104			; blanking start
vbe	equ	$FFC106			; blanking end
vdb	equ	$FFC108			; vertical display start
vde	equ	$FFC10A			; vertical display end
vi	equ	$FFC10C			; vertical interrupt
vcp	equ	$FFC10E			; vertical count
hp	equ	$FFC110			; horizontal period
hs	equ	$FFC112			; horizontal sync
hbb	equ	$FFC114			; blanking start
hbe	equ	$FFC116			; blanking end
hdb	equ	$FFC118			; horizontal display start
hde	equ	$FFC11A			; horizontal display stop
hi	equ	$FFC11C			; horizontal interrupt
viden	equ	$FFC120			; video enable
test	equ	$FFC122			; test register
palette	equ	$FFD000			; palette

pad0x	equ	$FFC031			; paddle registers
pad0y	equ	$FFC033
pad1x	equ	$FFC035
pad1y	equ	$FFC037

hite_off	equ	256		; offset for height

xs	equ	$1000			; xsize multiplier
dw	equ	$400000			; drawn width multiplier

width_mult equ	$401000			; the combination of the above pair

pal_off	equ	$1000000		; palette offset multiplier

HBORD	equ	5
FIELD	equ	260
NLINES	equ	200
START	equ	30			; display starts here

clock	equ	32



setup:	movea.l	#$1000,a7		; set SSP
	move	#$2100,sr

	movea.l	#OL,a0
	movea.l	#$400,a1
	move.w	#size_list,d0
list_LOOP:
	move.l	(a0)+,d1
	move.l	d1,(a1)+
	dbra	d0,list_LOOP

	move.l	#FIXUPS,d0
	sub.l	#OL,d0
	add.l	#1024,d0
	asr	#2,d0
	move.w	d0,1024+6

	move.w	#(16*clock),hp		; 64us/line
	move.w	#(15*clock),hs		; 4us horizontal sync
	move.w	#(14*clock),hbb		; 12us horizontal blanking
	move.w	#clock,hbe
	move.w	#(2*clock)+((3*clock)/4),hdb	; put display in the middle

	move.w	#FIELD,vp			; 
	move.w	#FIELD-4,vs			;
	move.w	#START+NLINES+HBORD,vbb		; 
	move.w	#START-HBORD,vbe
	move.w	#START,vdb
	move.w	#START+NLINES,vde
	move.w	#$8000,binit		; background to 0
	move.l	#$400,d0
	asr.l	#2,d0
	move.w	d0,olp			; point at object list
	move.w	#START+0,vcp		; object processor starts here
	move.w	#$FFFE,vi		; Set vertical interrupt off
	move.w	#$FFFE,hi		; Set horizontal interrupt off
	move.w	#3,viden		; go!

setpal:	move.l	#paldata,a0		; initialise palette
	move.l	#palette,a1
	move.w	#(32*4),d0
paloop:
	move.b	(a0),d1		  	; the palette only goes to $1f
	asl.b	#3,d1			; multiply by 8
	add.b	(a0)+,d1		; add in the original
	move.b	d1,(a1)+		; to get 6 bits
	dbra	d0,paloop

; This stuff gets back to the debugger

	pea.l	msg
	move.w	#$F000,-(sp)
	move.w	#5,-(sp)
	move.w	#11,-(sp)
	trap	#14
	add.w	#10,sp
msg:	dc.b	"Program now executing",0

